com.unitech.lib.params

## Class BaseParam

- java.lang.Object
- - com.unitech.lib.params.BaseParam

- Direct Known Subclasses:
    DeviceParam, EngineParam

      public class BaseParam
      extends Object

  The BaseParam class is a base class for DeviceParam and EngineParam. It defines common properties and methods for managing parameters.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected String` | `_default`
    `protected int` | `_max`
    `protected int` | `_maxVersion`
    `protected int` | `_min`
    `protected int` | `_minVersion`
    `protected ArrayList<String>` | `_options`
    `protected String` | `_value`
    `ParamType` | `type`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BaseParam(ParamType paramType)` Constructs a new BaseParam object.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getMaxVersion()` Returns the maximum version that supports the parameter.
    `int` | `getMinVersion()` Returns the minimum version that supports the parameter.
    `DeviceParam` | `toDeviceParam()` In child classes, this method is override to return a DeviceParam.
    `EngineParam` | `toEngineParam()` In child classes, this method is override to return an EngineParam.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _value

          protected String _value

    - #### _default

          protected String _default

    - #### _options

          protected ArrayList<String> _options

    - #### _min

          protected int _min

    - #### _max

          protected int _max

    - #### _minVersion

          protected int _minVersion

    - #### _maxVersion

          protected int _maxVersion

    - #### type

          public final ParamType type

  - ### Constructor Detail

    - #### BaseParam

          public BaseParam(ParamType paramType)

      Constructs a new BaseParam object.
      Parameters:
        `paramType` - The type of the parameter.

  - ### Method Detail

    - #### toDeviceParam

          public DeviceParam toDeviceParam()
                                    throws Exception

      In child classes, this method is override to return a DeviceParam.
      Returns:
        A DeviceParam object representing the current BaseParam.
      Throws:
        `Exception` - If the object is not a DeviceParam.

    - #### toEngineParam

          public EngineParam toEngineParam()
                                    throws Exception

      In child classes, this method is override to return an EngineParam.
      Returns:
        An EngineParam object representing the current BaseParam.
      Throws:
        `Exception` - If the object is not an EngineParam.

    - #### getMinVersion

          public int getMinVersion()

      Returns the minimum version that supports the parameter.
      Returns:
        The minimum version.

    - #### getMaxVersion

          public int getMaxVersion()

      Returns the maximum version that supports the parameter.
      Returns:
        The maximum version.